import math
from RNGen import *
from common3Cat import *


def sqr( v ):
    return v * v

def MyLog( x ):
    v = 0.0
    if (x > 1.0e-308):
        v = math.log(x)
    else:
        v = math.log(1.0e-308)
    return v

def MyExp( x ):
    v = 1.0
    if (x < 709.0):
        v = math.exp(x)
    else:
        v = math.exp(709.0)
    return v

def exp0( x ):
    if (x > 0.0):
        return 1.0
    else:
        return math.exp(x)

def LogL( X, n, C1, C2, sgm ):
    sum = 0.0
    for i in range(0, n):
        if X[i][1] == 3:
            sum += MyLog( cum_normalKC((X[i][0] - C2) / sgm) )
        elif X[i][1] == 1:
            sum += MyLog( 1.0 - cum_normalKC((X[i][0] - C1) / sgm) )
        else:
            sum += MyLog( cum_normalKC((X[i][0] - C1) / sgm) - cum_normalKC((X[i][0] - C2) / sgm) )
    return sum

def scale_sgm( acpt_r, ck ):
    v = 1.0
    if (acpt_r > 0.5):
        ck += 1
        v = 1.0 + 2.0 * (acpt_r - 0.4) / 0.6
    elif (acpt_r < 0.3):
        ck += 1
        v = 1.0 / (1.0 + 2.0 * (0.4 - acpt_r) / 0.4)
    return v, ck
    
def mcmcFunc( params ):
    n_jump = params['jump']
    n = params['n']
    tempX = params['X']
    X = []
    for data in tempX:
        X.append(data)
    NSimu = params['NSimu']
    C1 = []
    C1.append(params['initC1'])
    C2 = []
    C2.append(params['initC2'])
    Sgm = []
    Sgm.append(params['initSgm'])
    genSgmC1 = params['genSgmC1']
    genSgmC2 = params['genSgmC2']
    genSgmSgm = params['genSgmSgm']
    cnt_C1 = 0
    cnt_C2 = 0
    cnt_sgm = 0

    rn = RNp2to191()
    for i in range(0, n_jump):
        rn.jump(100)
              
    for t in range(0, NSimu):
        if (t % 500) == 0:
            print("{}/{}...jump = {}".format(t, NSimu, n_jump))
        a = 0.0
        y = rn.normalMS(C1[t], genSgmC1)
        if (y >= C2[t]):
            a = -1.0
        else:
            num = LogL( X, n, y, C2[t], Sgm[t] )
            den = LogL( X, n, C1[t], C2[t], Sgm[t] )
            a = exp0(num - den)
        if rn.uni() < a:
            C1.append(y)
            cnt_C1 += 1
        else:
            C1.append(C1[t])

        y = rn.normalMS(C2[t], genSgmC2)
        if (y <= C1[t + 1]):
            a = -1.0
        else:
            num = LogL( X, n, C1[t + 1], y, Sgm[t] )
            den = LogL( X, n, C1[t + 1], C2[t], Sgm[t] )
            a = exp0(num - den)
        if rn.uni() < a:
            C2.append(y)
            cnt_C2 += 1
        else:
            C2.append(C2[t])

        y = rn.normalMS(Sgm[t], genSgmSgm)
        if y <= 0.0:
            a = -1.0
        else:
            num = LogL( X, n, C1[t + 1], C2[t + 1], y )
            den = LogL( X, n, C1[t + 1], C2[t + 1], Sgm[t] )
            a = exp0(num - den)
        if rn.uni() < a:
            Sgm.append(y)
            cnt_sgm += 1
        else:
            Sgm.append(Sgm[t])

    return C1, C2, Sgm, cnt_C1, cnt_C2, cnt_sgm

            



